﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace UltraGridWithImageColumnFilter
{

    public class mmm
    {
        public string aa;

        public mmm()
        {

        }

    }

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.CreationFilter = new CreatingTextUIElement();

            DataTable dt = new DataTable();
            dt.Columns.Add("Image", typeof(Image));
            dt.Columns.Add("Value", typeof(string));

            Image im1 = Resource1.Image1;
            Image im2 = Resource1.Image2;
            im1.Tag = "Create";
            im2.Tag = "Delete";


            dt.Rows.Add(im1, "Item 1");
            dt.Rows.Add(im2, "Item 2");
            dt.Rows.Add(im2, "Item 3");
            ultraGrid1.DataSource = dt;
        }

        private void ultraGrid1_BeforeRowFilterDropDown(object sender, BeforeRowFilterDropDownEventArgs e)
        {
            int k = 0;
            while (k < e.ValueList.ValueListItems.Count)
            {
                ValueListItem item = e.ValueList.ValueListItems[k];
                if (item.DataValue.GetType() != typeof(Bitmap))
                {
                    e.ValueList.ValueListItems.Remove(item);
                    continue;
                }
                k++;
                item.Appearance.Image = item.DataValue;
                item.DisplayText = ((Bitmap)item.DataValue).Tag.ToString();// k.ToString();
            }
            ValueListItem vli = new ValueListItem(null, "All");
            e.ValueList.ValueListItems.Insert(0, vli);
        }

        private void ultraGrid1_FilterCellValueChanged(object sender, FilterCellValueChangedEventArgs e)
        {
            if (e.FilterCell.Text == "All") ultraGrid1.DisplayLayout.Bands[0].ColumnFilters.ClearAllFilters();
            CreatingTextUIElement.FilterValue = e.FilterCell.Text;
        }
    }

    public class CreatingTextUIElement : IUIElementCreationFilter
    {
        public static string FilterValue;

        public void AfterCreateChildElements(UIElement parent)
        {
            EditorWithTextDisplayTextUIElement El = parent as EditorWithTextDisplayTextUIElement;

            if (El != null && El.Parent.Parent.GetType() == typeof(EditorWithComboUIElement))
            {
                El.Text = FilterValue;
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

}
